Imports System.Runtime.InteropServices
Imports AddinExpress.OL
  
Public Class ADXOlForm1

    Private isExplorer As Boolean = False

    Public Sub New()
        MyBase.New()
  
        InitializeComponent()
  
    End Sub
  
    Private Sub ButtonCheckForms_Click(sender As System.Object, e As System.EventArgs) Handles ButtonCheckForms.Click

        Dim text As String = String.Empty
        Dim I, J As Integer
        For I = 0 To Me.FormsManager.Items.Count - 1
            For J = 0 To Me.FormsManager.Items(I).FormInstanceCount - 1
                Dim form As ADXOlForm = _
                    Me.FormsManager.Items(I).FormInstances(J)
                If form IsNot Nothing AndAlso form IsNot Me Then
                    text = text + _
                        form.Text + Environment.NewLine + _
                        "State: " + GetFormState(form).ToString() + _
                        Environment.NewLine + _
                        "Region: " + GetFormRegion(form).ToString() + _
                        Environment.NewLine + Environment.NewLine
                    DirectCast(form, ADXOlForm1).TextBoxDetails.Clear()
                End If
            Next J
        Next I

        TextBoxDetails.Text = _
            "--- THIS FORM: ---" + Environment.NewLine + _
            Me.Text + Environment.NewLine + _
            "State: " + GetFormState(Me).ToString() + _
            Environment.NewLine + _
            "Region: " + GetFormRegion(Me).ToString() + _
            Environment.NewLine + Environment.NewLine + _
            "--- OTHER FORMS: ---" + Environment.NewLine + _
            text
    End Sub

    Public Function GetFormRegion(ByVal Instance As ADXOlForm) As Object
        If DirectCast(Instance, ADXOlForm1).isExplorer Then
            Return Instance.Item.ExplorerLayout
        End If
        Return Instance.Item.InspectorLayout
    End Function

    Public Enum FormState
        Focused
        Visible
        InRegion
        InCache
    End Enum

    Public Function GetFormState(ByVal Instance As ADXOlForm) As FormState
        If Instance.Visible AndAlso _
            Instance.Active AndAlso _
            CheckFocused(Instance) Then
            Return FormState.Focused
        End If
        If Instance.Visible AndAlso Instance.Active Then
            Return FormState.Visible
        End If
        If Instance.Visible Then
            Return FormState.InRegion
        End If
        Return FormState.InCache
    End Function

    Public Function CheckFocused(ByVal Instance As ADXOlForm) As Boolean
        For I As Integer = 0 To Instance.Controls.Count - 1
            If Instance.Controls(I).Focused Then
                Return True
            End If
        Next I
        Return False
    End Function

    Private Sub ADXOlForm1_ADXBeforeFormShow() Handles MyBase.ADXBeforeFormShow
        If Me.Text = "ADXOlForm1" Then
            If Me.ExplorerObj IsNot Nothing Then
                Me.isExplorer = True
                Me.Text = "Explorer Form " + (Me.Item.Collection.IndexOf(Me.Item) - 1).ToString()
            End If
            If Me.InspectorObj IsNot Nothing Then
                Me.isExplorer = False
                Me.Text = "Inspector Form " + (Me.Item.Collection.IndexOf(Me.Item) + 1).ToString()
            End If
        End If
    End Sub
End Class
